package javathreadsprezi;

class JavaThreadsDemo2 implements JavaThreadsDemoable {

    private static final int loopCount = 500;

    private static void doLoop(int threadNum) {
        for (int i = 0; i < loopCount; i++) {
            System.out.println("This is "+Thread.currentThread().getName());
            
//            Thread.yield();
            
            try {
                Thread.sleep(2);
            } catch (InterruptedException ex) {
                break;
            }
        }
    }

    @Override
    public void doDemo() {
        Thread[] myThreads = new Thread[6];
        myThreads[0] = new Thread();
        myThreads[1] = new Thread() {
            @Override
            public void run() {
                doLoop(1);
            }
        };
        myThreads[2] = new MyThread();
        myThreads[3] = new Thread(new MyRunnable());
        myThreads[4] = new Thread(new MyRunnable());
        myThreads[5] = new Thread(new MyRunnable());
//        myThreads[6] = new Thread(new MyRunnable());
//        myThreads[7] = new Thread(new MyRunnable());
//        myThreads[8] = new Thread(new MyRunnable());
//        myThreads[9] = new Thread(new MyRunnable());
//        myThreads[10] = new Thread(new MyRunnable());
//        myThreads[11] = new Thread(new MyRunnable());
        
        for (Thread myThread : myThreads) {
            myThread.start();
        }
    }

    private class MyThread extends Thread {

        @Override
        public void run() {
            doLoop(2);
        }
    }

    private class MyRunnable implements Runnable {

        @Override
        public void run() {
            doLoop(3);
        }
    }
}
