package javathreadsprezi;

class JavaThreadsDemo4 implements JavaThreadsDemoable {

    private StringBuilder myStringBuilder = new StringBuilder();
    private final Object lock = new Object();

    @Override
    public void doDemo() {
        int sbuNum = 26;
        StringBuilderUser[] sbus = new StringBuilderUser[sbuNum];
        for (int i = 0; i < sbuNum; i++) {
            sbus[i] = new StringBuilderUser((char) (i + 97));
        }
        for (StringBuilderUser sbu : sbus) {
            new Thread(sbu).start();
        }

        for (int i = 0; i < 10; i++) {
            System.out.println(myStringBuilder);
            try {
                Thread.sleep(200);
            } catch (InterruptedException ex) {
            }
        }

        for (StringBuilderUser sbu : sbus) {
            sbu.stop();
        }
    }

    private class StringBuilderUser implements Runnable {

        private final char ch;
        private boolean running = true;

        public StringBuilderUser(char ch) {
            this.ch = ch;
        }

        @Override
        public void run() {
            while (running) {
                synchronized (myStringBuilder) {
                    myStringBuilder.append(ch);
                    myStringBuilder.append(ch);
                }
//                Thread.yield();
                try {
                    Thread.sleep(100);
                } catch (InterruptedException ex) {
                    break;
                }
            }
        }

        public void stop() {
            running = false;
        }
    }
}
