package javathreadsprezi;

import java.awt.Dimension;
import java.awt.EventQueue;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.JFrame;

class JavaThreadsDemo5 implements JavaThreadsDemoable {

    @Override
    public void doDemo() {
        java.util.Timer timer = new Timer();
        timer.schedule(new MyTimerTask(), 100, 100);
        try {
            Thread.sleep(2000);
        } catch (InterruptedException ex) {
        }
        timer.cancel();
    }

    private class MyTimerTask extends TimerTask {

        @Override
        public void run() {
            EventQueue.invokeLater(new Runnable() {
                @Override
                public void run() {
                    System.out.println(Thread.currentThread().getName());
                    JFrame frame = new MyPopupFrame();
                    frame.setVisible(true);
                }
            });
        }
    }

    private class MyPopupFrame extends JFrame {

        public MyPopupFrame() {
            setTitle("Frame");
            setDefaultCloseOperation(DISPOSE_ON_CLOSE);
            setSize(new Dimension(150, 30));
            setLocation((int) (Math.random() * 800), (int) (Math.random() * 600));
        }
    }
}
